【LeetCode热题100】【双指针】接雨水

给定 n 个非负整数表示每个宽度为 1 的柱子的高度图,计算按此排列的柱子,下雨之后能接多少雨水。

示例 1:

复制代码
输入:height = [0,1,0,2,1,0,1,3,2,1,2,1]
输出:6
解释:上面是由数组 [0,1,0,2,1,0,1,3,2,1,2,1] 表示的高度图,在这种情况下,可以接 6 个单位的雨水(蓝色部分表示雨水)。 

示例 2:

复制代码
输入:height = [4,2,0,3,2,5]
输出:9

提示:

  • n == height.length
  • 1 <= n <= 2 * 104
  • 0 <= height[i] <= 105

题解

这道题是双指针里面困难级别的题

我一开始的想法是用两个指针分别从左右两边出发,两边都是判断当前木板的高度是否低于先前碰到的最高的木板,如果是,那么累加二者的高度差,这样的思路基于一个前提:前面存在更高木板可以把水给罩住

但是存在一种情况,那就是一开始碰到的木板就是最高的,所以这种思路不行

官方给的思路是左右两边都计算一次,然后取二者间最小的

我在实现官方的思路的时候,想到了一种新的方法,一开始就去找到最高的那个木板所在的地方,仍然从左右两边出发去计算,但是碰到最高的地方我就停下来不算了

完美解决

复制代码
class Solution {
public:
    int trap(vector<int> &height) {
        int highest = 0;
        for (int i = 0; i < height.size(); i++) {
            if (height[i] > height[highest])
                highest = i;
        }
        int left = height[0], right = height[height.size() - 1], drop = 0, i = 1, j = height.size() - 2;
        while (i < highest) {
            if (height[i] < left) {
                drop += left - height[i];
            } else {
                left = height[i];
            }
            i++;
        }
        while (j>highest) {
            if (height[j] < right) {
                drop += right - height[j];
            } else {
                right = height[j];
            }
            j--;
        }
        return drop;
    }
};
相关推荐
碧海银沙音频科技研究院3 分钟前
基于炬芯ATS3089X自研AEC声学回声消除算法
算法
通问AI23 分钟前
在两台 Mac Studio 上跑 800B 模型:MLX + RDMA over Thunderbolt 实测与四道门选型法
算法
ZywOo62324 分钟前
《算法竞赛进阶指南》0x03 前缀和与差分
算法
Scintilla_y30 分钟前
DAY2 滑动窗口
算法·leetcode·散列表
lvwangshu31 分钟前
笛卡尔树
算法·图论
026d231 小时前
状态信号只知“其然”不知“其所以然”:变工况机械故障诊断的物理盲区
算法
姜鱼问生1 小时前
备份和服务器在同一台机器上,等于没备份
算法·架构
姜鱼问生1 小时前
别再 chmod 777 了,用 ACL 给它开一扇窗
后端·算法·架构
特立独行的猫a2 小时前
仓颉语言UI开发实战:我用仓颉写了个桌面版力扣
算法·leetcode·ui·tauri·仓颉·cj-tarui
y1su2 小时前
Leetcode 动态规划 模板
java·数据结构·算法·leetcode·动态规划